﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ship
{
    internal class WaterMap : AbstractMap
    {
        private readonly Brush barrierColor = new SolidBrush(Color.Red);
        private readonly Brush roadColor = new SolidBrush(Color.Blue);
        protected override void DrawBarrierPart(Graphics g, int i, int j)
        {
            g.FillRectangle(barrierColor, i * _size_x, j * _size_y, i * (_size_x + 1), j * (_size_y + 1));
        }
        protected override void DrawRoadPart(Graphics g, int i, int j)
        {
            g.FillRectangle(roadColor, i * _size_x, j * _size_y, i * (_size_x + 1), j * (_size_y + 1));
        }
        protected override void GenerateMap()
        {
            _map = new int[50, 50];
            _size_x = (float)_width / _map.GetLength(0);
            _size_y = (float)_height / _map.GetLength(1);
            int counter = 0;
            for (int i = 0; i < _map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    _map[i, j] = _freeRoad;
                }
            }
            while (counter < 10)
            {
                int x = _random.Next(2, 48);
                int y = _random.Next(3, 48);
                var points = new int[] { _map[x, y], _map[x, y + 1], _map[x - 1, y + 1], _map[x + 1, y + 1] };
                var forComparison = new int[] { _freeRoad, _freeRoad, _freeRoad, _freeRoad };
                if (points.SequenceEqual(forComparison))
                {
                    _map[x, y] = _barrier;
                    _map[x, y + 1] = _barrier;
                    _map[x + 1, y + 1] = _barrier;
                    _map[x - 1, y + 1] = _barrier;
                    counter++;
                }
            }
        }
    }
}
